Index: /trunk/sources/HeuristicLab 3.3.sln
===================================================================
--- /trunk/sources/HeuristicLab 3.3.sln	(revision 5190)
+++ /trunk/sources/HeuristicLab 3.3.sln	(revision 5191)
@@ -26,6 +26,4 @@
 EndProject
 Project("{2150E333-8FDC-42A3-9474-1A3956D46DE8}") = "HeuristicLab.ALGLIB", "HeuristicLab.ALGLIB", "{F0D06B07-1CB3-418E-88ED-CAE8DAACC7E0}"
-EndProject
-Project("{2150E333-8FDC-42A3-9474-1A3956D46DE8}") = "HeuristicLab.ALGLIB-2.5.0", "HeuristicLab.ALGLIB-2.5.0", "{F1A195C9-98CD-47C6-9B74-3344EB258C5D}"
 EndProject
 Project("{2150E333-8FDC-42A3-9474-1A3956D46DE8}") = "HeuristicLab.LibSVM", "HeuristicLab.LibSVM", "{782DDDA3-A7A3-404E-B751-6200CE2D5EF3}"
@@ -79,5 +77,4 @@
 		{6A5F8C2D-B0C3-4B36-BC20-9B1A91EE6DB6} = {6A5F8C2D-B0C3-4B36-BC20-9B1A91EE6DB6}
 		{1849A92E-DCFC-4E05-BB0A-D7B7A3DAFCFB} = {1849A92E-DCFC-4E05-BB0A-D7B7A3DAFCFB}
-		{29E4B033-1FEF-4FE1-AE17-0A9319D7C54E} = {29E4B033-1FEF-4FE1-AE17-0A9319D7C54E}
 		{250ADE34-82FD-4BAE-86D5-985FBE589C4A} = {250ADE34-82FD-4BAE-86D5-985FBE589C4A}
 		{C3E69936-0DB5-42A4-B1B4-12E9700B080E} = {C3E69936-0DB5-42A4-B1B4-12E9700B080E}
@@ -96,5 +93,4 @@
 		{3BD61258-31DA-4B09-89C0-4F71FEF5F05A} = {3BD61258-31DA-4B09-89C0-4F71FEF5F05A}
 		{DE69A359-A5B8-4D3D-BA8D-D5780D7F96D6} = {DE69A359-A5B8-4D3D-BA8D-D5780D7F96D6}
-		{01BBCB5A-144A-4A7E-908E-079849E2F7CF} = {01BBCB5A-144A-4A7E-908E-079849E2F7CF}
 		{96E5ED5B-187D-4012-9CDA-D85CDAD38342} = {96E5ED5B-187D-4012-9CDA-D85CDAD38342}
 		{E86E215D-E3CE-4244-978D-555D4E17AC09} = {E86E215D-E3CE-4244-978D-555D4E17AC09}
@@ -275,8 +271,4 @@
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.TestFunctions-3.3.Tests", "HeuristicLab.Problems.TestFunctions\3.3\Tests\HeuristicLab.Problems.TestFunctions-3.3.Tests.csproj", "{71D904D9-233B-44B2-ABB2-1525691228C5}"
-EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "ALGLIB-2.5.0", "HeuristicLab.ExtLibs\HeuristicLab.ALGLIB\2.5.0\ALGLIB-2.5.0\ALGLIB-2.5.0.csproj", "{29E4B033-1FEF-4FE1-AE17-0A9319D7C54E}"
-EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.ALGLIB-2.5.0", "HeuristicLab.ExtLibs\HeuristicLab.ALGLIB\2.5.0\HeuristicLab.ALGLIB-2.5.0\HeuristicLab.ALGLIB-2.5.0.csproj", "{01BBCB5A-144A-4A7E-908E-079849E2F7CF}"
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "LibSVM-1.6.3", "HeuristicLab.ExtLibs\HeuristicLab.LibSVM\1.6.3\LibSVM-1.6.3\LibSVM-1.6.3.csproj", "{A16F23B5-FB62-499E-A831-26953AA56FE2}"
@@ -1186,28 +1178,4 @@
 		{71D904D9-233B-44B2-ABB2-1525691228C5}.Release|x86.ActiveCfg = Release|x86
 		{71D904D9-233B-44B2-ABB2-1525691228C5}.Release|x86.Build.0 = Release|x86
-		{29E4B033-1FEF-4FE1-AE17-0A9319D7C54E}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{29E4B033-1FEF-4FE1-AE17-0A9319D7C54E}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{29E4B033-1FEF-4FE1-AE17-0A9319D7C54E}.Debug|x64.ActiveCfg = Debug|x64
-		{29E4B033-1FEF-4FE1-AE17-0A9319D7C54E}.Debug|x64.Build.0 = Debug|x64
-		{29E4B033-1FEF-4FE1-AE17-0A9319D7C54E}.Debug|x86.ActiveCfg = Debug|x86
-		{29E4B033-1FEF-4FE1-AE17-0A9319D7C54E}.Debug|x86.Build.0 = Debug|x86
-		{29E4B033-1FEF-4FE1-AE17-0A9319D7C54E}.Release|Any CPU.ActiveCfg = Release|Any CPU
-		{29E4B033-1FEF-4FE1-AE17-0A9319D7C54E}.Release|Any CPU.Build.0 = Release|Any CPU
-		{29E4B033-1FEF-4FE1-AE17-0A9319D7C54E}.Release|x64.ActiveCfg = Release|x64
-		{29E4B033-1FEF-4FE1-AE17-0A9319D7C54E}.Release|x64.Build.0 = Release|x64
-		{29E4B033-1FEF-4FE1-AE17-0A9319D7C54E}.Release|x86.ActiveCfg = Release|x86
-		{29E4B033-1FEF-4FE1-AE17-0A9319D7C54E}.Release|x86.Build.0 = Release|x86
-		{01BBCB5A-144A-4A7E-908E-079849E2F7CF}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{01BBCB5A-144A-4A7E-908E-079849E2F7CF}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{01BBCB5A-144A-4A7E-908E-079849E2F7CF}.Debug|x64.ActiveCfg = Debug|x64
-		{01BBCB5A-144A-4A7E-908E-079849E2F7CF}.Debug|x64.Build.0 = Debug|x64
-		{01BBCB5A-144A-4A7E-908E-079849E2F7CF}.Debug|x86.ActiveCfg = Debug|x86
-		{01BBCB5A-144A-4A7E-908E-079849E2F7CF}.Debug|x86.Build.0 = Debug|x86
-		{01BBCB5A-144A-4A7E-908E-079849E2F7CF}.Release|Any CPU.ActiveCfg = Release|Any CPU
-		{01BBCB5A-144A-4A7E-908E-079849E2F7CF}.Release|Any CPU.Build.0 = Release|Any CPU
-		{01BBCB5A-144A-4A7E-908E-079849E2F7CF}.Release|x64.ActiveCfg = Release|x64
-		{01BBCB5A-144A-4A7E-908E-079849E2F7CF}.Release|x64.Build.0 = Release|x64
-		{01BBCB5A-144A-4A7E-908E-079849E2F7CF}.Release|x86.ActiveCfg = Release|x86
-		{01BBCB5A-144A-4A7E-908E-079849E2F7CF}.Release|x86.Build.0 = Release|x86
 		{A16F23B5-FB62-499E-A831-26953AA56FE2}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{A16F23B5-FB62-499E-A831-26953AA56FE2}.Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -1518,8 +1486,5 @@
 		{BB994448-2B21-4564-BB2E-38D8FFF8CF18} = {0A3CE05D-4FCD-40A4-9001-D57627554BBC}
 		{4ABA047D-46DD-4608-9E4A-41C5F92FDBB1} = {F94E41E4-F25F-4302-8486-0BEF121CF5C8}
-		{F1A195C9-98CD-47C6-9B74-3344EB258C5D} = {F0D06B07-1CB3-418E-88ED-CAE8DAACC7E0}
 		{91243D2B-77EB-4922-BEB0-78C6AB1DEEDC} = {F0D06B07-1CB3-418E-88ED-CAE8DAACC7E0}
-		{29E4B033-1FEF-4FE1-AE17-0A9319D7C54E} = {F1A195C9-98CD-47C6-9B74-3344EB258C5D}
-		{01BBCB5A-144A-4A7E-908E-079849E2F7CF} = {F1A195C9-98CD-47C6-9B74-3344EB258C5D}
 		{16A50D44-107B-4601-A291-3B6870CD919D} = {782DDDA3-A7A3-404E-B751-6200CE2D5EF3}
 		{A16F23B5-FB62-499E-A831-26953AA56FE2} = {16A50D44-107B-4601-A291-3B6870CD919D}
Index: /trunk/sources/HeuristicLab/3.3/Tests/HeuristicLab-3.3.Tests.csproj
===================================================================
--- /trunk/sources/HeuristicLab/3.3/Tests/HeuristicLab-3.3.Tests.csproj	(revision 5190)
+++ /trunk/sources/HeuristicLab/3.3/Tests/HeuristicLab-3.3.Tests.csproj	(revision 5191)
@@ -239,12 +239,4 @@
       <Name>HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.3</Name>
     </ProjectReference>
-    <ProjectReference Include="..\..\..\HeuristicLab.ExtLibs\HeuristicLab.ALGLIB\2.5.0\ALGLIB-2.5.0\ALGLIB-2.5.0.csproj">
-      <Project>{29E4B033-1FEF-4FE1-AE17-0A9319D7C54E}</Project>
-      <Name>ALGLIB-2.5.0</Name>
-    </ProjectReference>
-    <ProjectReference Include="..\..\..\HeuristicLab.ExtLibs\HeuristicLab.ALGLIB\2.5.0\HeuristicLab.ALGLIB-2.5.0\HeuristicLab.ALGLIB-2.5.0.csproj">
-      <Project>{01BBCB5A-144A-4A7E-908E-079849E2F7CF}</Project>
-      <Name>HeuristicLab.ALGLIB-2.5.0 %28HeuristicLab.ExtLibs\HeuristicLab.ALGLIB\HeuristicLab.ALGLIB-2.5.0\HeuristicLab.ALGLIB-2.5.0%29</Name>
-    </ProjectReference>
     <ProjectReference Include="..\..\..\HeuristicLab.ExtLibs\HeuristicLab.ALGLIB\3.1.0\ALGLIB-3.1.0\ALGLIB-3.1.0.csproj">
       <Project>{FC841674-62A7-4055-BE91-E41944B6C606}</Project>